# coding: utf-8

"""
    Cloud Manager API

    This API allows access to Cloud Manager programs, pipelines, and environments by an authorized technical account created through the Adobe I/O Console. The base url for this API is https://cloudmanager.adobe.io, e.g. to get the list of programs for an organization, you would make a GET request to https://cloudmanager.adobe.io/api/programs (with the correct set of headers as described below). This swagger file can be downloaded from https://raw.githubusercontent.com/AdobeDocs/cloudmanager-api-docs/master/swagger-specs/api.yaml.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: opensource@shinesolutions.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pyaemcloudmanagerapi.configuration import Configuration


class BadRequestError(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'status': 'int',
        'type': 'str',
        'title': 'str',
        'missing_params': 'list[MissingParameter]',
        'invalid_params': 'list[InvalidParameter]'
    }

    attribute_map = {
        'status': 'status',
        'type': 'type',
        'title': 'title',
        'missing_params': 'missingParams',
        'invalid_params': 'invalidParams'
    }

    def __init__(self, status=None, type=None, title=None, missing_params=None, invalid_params=None, local_vars_configuration=None):  # noqa: E501
        """BadRequestError - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._status = None
        self._type = None
        self._title = None
        self._missing_params = None
        self._invalid_params = None
        self.discriminator = None

        if status is not None:
            self.status = status
        if type is not None:
            self.type = type
        if title is not None:
            self.title = title
        if missing_params is not None:
            self.missing_params = missing_params
        if invalid_params is not None:
            self.invalid_params = invalid_params

    @property
    def status(self):
        """Gets the status of this BadRequestError.  # noqa: E501

        HTTP status code of the response.  # noqa: E501

        :return: The status of this BadRequestError.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this BadRequestError.

        HTTP status code of the response.  # noqa: E501

        :param status: The status of this BadRequestError.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def type(self):
        """Gets the type of this BadRequestError.  # noqa: E501

        Error type identifier.  # noqa: E501

        :return: The type of this BadRequestError.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this BadRequestError.

        Error type identifier.  # noqa: E501

        :param type: The type of this BadRequestError.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def title(self):
        """Gets the title of this BadRequestError.  # noqa: E501

        A short summary of the error.  # noqa: E501

        :return: The title of this BadRequestError.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this BadRequestError.

        A short summary of the error.  # noqa: E501

        :param title: The title of this BadRequestError.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def missing_params(self):
        """Gets the missing_params of this BadRequestError.  # noqa: E501

        Request's missing parameters.  # noqa: E501

        :return: The missing_params of this BadRequestError.  # noqa: E501
        :rtype: list[MissingParameter]
        """
        return self._missing_params

    @missing_params.setter
    def missing_params(self, missing_params):
        """Sets the missing_params of this BadRequestError.

        Request's missing parameters.  # noqa: E501

        :param missing_params: The missing_params of this BadRequestError.  # noqa: E501
        :type: list[MissingParameter]
        """

        self._missing_params = missing_params

    @property
    def invalid_params(self):
        """Gets the invalid_params of this BadRequestError.  # noqa: E501

        Request's invalid parameters.  # noqa: E501

        :return: The invalid_params of this BadRequestError.  # noqa: E501
        :rtype: list[InvalidParameter]
        """
        return self._invalid_params

    @invalid_params.setter
    def invalid_params(self, invalid_params):
        """Sets the invalid_params of this BadRequestError.

        Request's invalid parameters.  # noqa: E501

        :param invalid_params: The invalid_params of this BadRequestError.  # noqa: E501
        :type: list[InvalidParameter]
        """

        self._invalid_params = invalid_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BadRequestError):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BadRequestError):
            return True

        return self.to_dict() != other.to_dict()
