# coding: utf-8

"""
    Cloud Manager API

    This API allows access to Cloud Manager programs, pipelines, and environments by an authorized technical account created through the Adobe I/O Console. The base url for this API is https://cloudmanager.adobe.io, e.g. to get the list of programs for an organization, you would make a GET request to https://cloudmanager.adobe.io/api/programs (with the correct set of headers as described below). This swagger file can be downloaded from https://raw.githubusercontent.com/AdobeDocs/cloudmanager-api-docs/master/swagger-specs/api.yaml.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: opensource@shinesolutions.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pyaemcloudmanagerapi.configuration import Configuration


class EnvironmentLogs(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'service': 'list[str]',
        'name': 'list[str]',
        'days': 'int',
        'links': 'EnvironmentLogsLinks',
        'embedded': 'EnvironmentLogsEmbedded'
    }

    attribute_map = {
        'service': 'service',
        'name': 'name',
        'days': 'days',
        'links': '_links',
        'embedded': '_embedded'
    }

    def __init__(self, service=None, name=None, days=None, links=None, embedded=None, local_vars_configuration=None):  # noqa: E501
        """EnvironmentLogs - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._service = None
        self._name = None
        self._days = None
        self._links = None
        self._embedded = None
        self.discriminator = None

        if service is not None:
            self.service = service
        if name is not None:
            self.name = name
        if days is not None:
            self.days = days
        if links is not None:
            self.links = links
        if embedded is not None:
            self.embedded = embedded

    @property
    def service(self):
        """Gets the service of this EnvironmentLogs.  # noqa: E501

        Name of the service  # noqa: E501

        :return: The service of this EnvironmentLogs.  # noqa: E501
        :rtype: list[str]
        """
        return self._service

    @service.setter
    def service(self, service):
        """Sets the service of this EnvironmentLogs.

        Name of the service  # noqa: E501

        :param service: The service of this EnvironmentLogs.  # noqa: E501
        :type: list[str]
        """

        self._service = service

    @property
    def name(self):
        """Gets the name of this EnvironmentLogs.  # noqa: E501

        Name of the Log  # noqa: E501

        :return: The name of this EnvironmentLogs.  # noqa: E501
        :rtype: list[str]
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EnvironmentLogs.

        Name of the Log  # noqa: E501

        :param name: The name of this EnvironmentLogs.  # noqa: E501
        :type: list[str]
        """

        self._name = name

    @property
    def days(self):
        """Gets the days of this EnvironmentLogs.  # noqa: E501

        Number of days  # noqa: E501

        :return: The days of this EnvironmentLogs.  # noqa: E501
        :rtype: int
        """
        return self._days

    @days.setter
    def days(self, days):
        """Sets the days of this EnvironmentLogs.

        Number of days  # noqa: E501

        :param days: The days of this EnvironmentLogs.  # noqa: E501
        :type: int
        """

        self._days = days

    @property
    def links(self):
        """Gets the links of this EnvironmentLogs.  # noqa: E501


        :return: The links of this EnvironmentLogs.  # noqa: E501
        :rtype: EnvironmentLogsLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this EnvironmentLogs.


        :param links: The links of this EnvironmentLogs.  # noqa: E501
        :type: EnvironmentLogsLinks
        """

        self._links = links

    @property
    def embedded(self):
        """Gets the embedded of this EnvironmentLogs.  # noqa: E501


        :return: The embedded of this EnvironmentLogs.  # noqa: E501
        :rtype: EnvironmentLogsEmbedded
        """
        return self._embedded

    @embedded.setter
    def embedded(self, embedded):
        """Sets the embedded of this EnvironmentLogs.


        :param embedded: The embedded of this EnvironmentLogs.  # noqa: E501
        :type: EnvironmentLogsEmbedded
        """

        self._embedded = embedded

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EnvironmentLogs):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EnvironmentLogs):
            return True

        return self.to_dict() != other.to_dict()
