# coding: utf-8

"""
    Cloud Manager API

    This API allows access to Cloud Manager programs, pipelines, and environments by an authorized technical account created through the Adobe I/O Console. The base url for this API is https://cloudmanager.adobe.io, e.g. to get the list of programs for an organization, you would make a GET request to https://cloudmanager.adobe.io/api/programs (with the correct set of headers as described below). This swagger file can be downloaded from https://raw.githubusercontent.com/AdobeDocs/cloudmanager-api-docs/master/swagger-specs/api.yaml.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: opensource@shinesolutions.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pyaemcloudmanagerapi.configuration import Configuration


class PipelineExecutionListRepresentationLinks(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'next': 'HalLink',
        'page': 'HalLink',
        'prev': 'HalLink',
        '_self': 'HalLink'
    }

    attribute_map = {
        'next': 'next',
        'page': 'page',
        'prev': 'prev',
        '_self': 'self'
    }

    def __init__(self, next=None, page=None, prev=None, _self=None, local_vars_configuration=None):  # noqa: E501
        """PipelineExecutionListRepresentationLinks - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._next = None
        self._page = None
        self._prev = None
        self.__self = None
        self.discriminator = None

        if next is not None:
            self.next = next
        if page is not None:
            self.page = page
        if prev is not None:
            self.prev = prev
        if _self is not None:
            self._self = _self

    @property
    def next(self):
        """Gets the next of this PipelineExecutionListRepresentationLinks.  # noqa: E501


        :return: The next of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._next

    @next.setter
    def next(self, next):
        """Sets the next of this PipelineExecutionListRepresentationLinks.


        :param next: The next of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :type: HalLink
        """

        self._next = next

    @property
    def page(self):
        """Gets the page of this PipelineExecutionListRepresentationLinks.  # noqa: E501


        :return: The page of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._page

    @page.setter
    def page(self, page):
        """Sets the page of this PipelineExecutionListRepresentationLinks.


        :param page: The page of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :type: HalLink
        """

        self._page = page

    @property
    def prev(self):
        """Gets the prev of this PipelineExecutionListRepresentationLinks.  # noqa: E501


        :return: The prev of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._prev

    @prev.setter
    def prev(self, prev):
        """Sets the prev of this PipelineExecutionListRepresentationLinks.


        :param prev: The prev of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :type: HalLink
        """

        self._prev = prev

    @property
    def _self(self):
        """Gets the _self of this PipelineExecutionListRepresentationLinks.  # noqa: E501


        :return: The _self of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self.__self

    @_self.setter
    def _self(self, _self):
        """Sets the _self of this PipelineExecutionListRepresentationLinks.


        :param _self: The _self of this PipelineExecutionListRepresentationLinks.  # noqa: E501
        :type: HalLink
        """

        self.__self = _self

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PipelineExecutionListRepresentationLinks):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PipelineExecutionListRepresentationLinks):
            return True

        return self.to_dict() != other.to_dict()
