# coding: utf-8

"""
    Cloud Manager API

    This API allows access to Cloud Manager programs, pipelines, and environments by an authorized technical account created through the Adobe I/O Console. The base url for this API is https://cloudmanager.adobe.io, e.g. to get the list of programs for an organization, you would make a GET request to https://cloudmanager.adobe.io/api/programs (with the correct set of headers as described below). This swagger file can be downloaded from https://raw.githubusercontent.com/AdobeDocs/cloudmanager-api-docs/master/swagger-specs/api.yaml.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: opensource@shinesolutions.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pyaemcloudmanagerapi.configuration import Configuration


class PipelineExecutionStepStateLinks(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'http__ns_adobe_com_adobecloud_rel_execution': 'HalLink',
        'http__ns_adobe_com_adobecloud_rel_pipeline': 'HalLink',
        'http__ns_adobe_com_adobecloud_rel_pipeline_logs': 'HalLink',
        'http__ns_adobe_com_adobecloud_rel_pipeline_metrics': 'HalLink',
        'http__ns_adobe_com_adobecloud_rel_pipeline_advance': 'HalLink',
        'http__ns_adobe_com_adobecloud_rel_pipeline_cancel': 'HalLink',
        'http__ns_adobe_com_adobecloud_rel_program': 'HalLink',
        '_self': 'HalLink'
    }

    attribute_map = {
        'http__ns_adobe_com_adobecloud_rel_execution': 'http://ns.adobe.com/adobecloud/rel/execution',
        'http__ns_adobe_com_adobecloud_rel_pipeline': 'http://ns.adobe.com/adobecloud/rel/pipeline',
        'http__ns_adobe_com_adobecloud_rel_pipeline_logs': 'http://ns.adobe.com/adobecloud/rel/pipeline/logs',
        'http__ns_adobe_com_adobecloud_rel_pipeline_metrics': 'http://ns.adobe.com/adobecloud/rel/pipeline/metrics',
        'http__ns_adobe_com_adobecloud_rel_pipeline_advance': 'http://ns.adobe.com/adobecloud/rel/pipeline/advance',
        'http__ns_adobe_com_adobecloud_rel_pipeline_cancel': 'http://ns.adobe.com/adobecloud/rel/pipeline/cancel',
        'http__ns_adobe_com_adobecloud_rel_program': 'http://ns.adobe.com/adobecloud/rel/program',
        '_self': 'self'
    }

    def __init__(self, http__ns_adobe_com_adobecloud_rel_execution=None, http__ns_adobe_com_adobecloud_rel_pipeline=None, http__ns_adobe_com_adobecloud_rel_pipeline_logs=None, http__ns_adobe_com_adobecloud_rel_pipeline_metrics=None, http__ns_adobe_com_adobecloud_rel_pipeline_advance=None, http__ns_adobe_com_adobecloud_rel_pipeline_cancel=None, http__ns_adobe_com_adobecloud_rel_program=None, _self=None, local_vars_configuration=None):  # noqa: E501
        """PipelineExecutionStepStateLinks - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._http__ns_adobe_com_adobecloud_rel_execution = None
        self._http__ns_adobe_com_adobecloud_rel_pipeline = None
        self._http__ns_adobe_com_adobecloud_rel_pipeline_logs = None
        self._http__ns_adobe_com_adobecloud_rel_pipeline_metrics = None
        self._http__ns_adobe_com_adobecloud_rel_pipeline_advance = None
        self._http__ns_adobe_com_adobecloud_rel_pipeline_cancel = None
        self._http__ns_adobe_com_adobecloud_rel_program = None
        self.__self = None
        self.discriminator = None

        if http__ns_adobe_com_adobecloud_rel_execution is not None:
            self.http__ns_adobe_com_adobecloud_rel_execution = http__ns_adobe_com_adobecloud_rel_execution
        if http__ns_adobe_com_adobecloud_rel_pipeline is not None:
            self.http__ns_adobe_com_adobecloud_rel_pipeline = http__ns_adobe_com_adobecloud_rel_pipeline
        if http__ns_adobe_com_adobecloud_rel_pipeline_logs is not None:
            self.http__ns_adobe_com_adobecloud_rel_pipeline_logs = http__ns_adobe_com_adobecloud_rel_pipeline_logs
        if http__ns_adobe_com_adobecloud_rel_pipeline_metrics is not None:
            self.http__ns_adobe_com_adobecloud_rel_pipeline_metrics = http__ns_adobe_com_adobecloud_rel_pipeline_metrics
        if http__ns_adobe_com_adobecloud_rel_pipeline_advance is not None:
            self.http__ns_adobe_com_adobecloud_rel_pipeline_advance = http__ns_adobe_com_adobecloud_rel_pipeline_advance
        if http__ns_adobe_com_adobecloud_rel_pipeline_cancel is not None:
            self.http__ns_adobe_com_adobecloud_rel_pipeline_cancel = http__ns_adobe_com_adobecloud_rel_pipeline_cancel
        if http__ns_adobe_com_adobecloud_rel_program is not None:
            self.http__ns_adobe_com_adobecloud_rel_program = http__ns_adobe_com_adobecloud_rel_program
        if _self is not None:
            self._self = _self

    @property
    def http__ns_adobe_com_adobecloud_rel_execution(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_execution of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_execution of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_execution

    @http__ns_adobe_com_adobecloud_rel_execution.setter
    def http__ns_adobe_com_adobecloud_rel_execution(self, http__ns_adobe_com_adobecloud_rel_execution):
        """Sets the http__ns_adobe_com_adobecloud_rel_execution of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_execution: The http__ns_adobe_com_adobecloud_rel_execution of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_execution = http__ns_adobe_com_adobecloud_rel_execution

    @property
    def http__ns_adobe_com_adobecloud_rel_pipeline(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_pipeline of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_pipeline of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_pipeline

    @http__ns_adobe_com_adobecloud_rel_pipeline.setter
    def http__ns_adobe_com_adobecloud_rel_pipeline(self, http__ns_adobe_com_adobecloud_rel_pipeline):
        """Sets the http__ns_adobe_com_adobecloud_rel_pipeline of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_pipeline: The http__ns_adobe_com_adobecloud_rel_pipeline of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_pipeline = http__ns_adobe_com_adobecloud_rel_pipeline

    @property
    def http__ns_adobe_com_adobecloud_rel_pipeline_logs(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_pipeline_logs of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_pipeline_logs of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_pipeline_logs

    @http__ns_adobe_com_adobecloud_rel_pipeline_logs.setter
    def http__ns_adobe_com_adobecloud_rel_pipeline_logs(self, http__ns_adobe_com_adobecloud_rel_pipeline_logs):
        """Sets the http__ns_adobe_com_adobecloud_rel_pipeline_logs of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_pipeline_logs: The http__ns_adobe_com_adobecloud_rel_pipeline_logs of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_pipeline_logs = http__ns_adobe_com_adobecloud_rel_pipeline_logs

    @property
    def http__ns_adobe_com_adobecloud_rel_pipeline_metrics(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_pipeline_metrics of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_pipeline_metrics of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_pipeline_metrics

    @http__ns_adobe_com_adobecloud_rel_pipeline_metrics.setter
    def http__ns_adobe_com_adobecloud_rel_pipeline_metrics(self, http__ns_adobe_com_adobecloud_rel_pipeline_metrics):
        """Sets the http__ns_adobe_com_adobecloud_rel_pipeline_metrics of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_pipeline_metrics: The http__ns_adobe_com_adobecloud_rel_pipeline_metrics of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_pipeline_metrics = http__ns_adobe_com_adobecloud_rel_pipeline_metrics

    @property
    def http__ns_adobe_com_adobecloud_rel_pipeline_advance(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_pipeline_advance of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_pipeline_advance of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_pipeline_advance

    @http__ns_adobe_com_adobecloud_rel_pipeline_advance.setter
    def http__ns_adobe_com_adobecloud_rel_pipeline_advance(self, http__ns_adobe_com_adobecloud_rel_pipeline_advance):
        """Sets the http__ns_adobe_com_adobecloud_rel_pipeline_advance of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_pipeline_advance: The http__ns_adobe_com_adobecloud_rel_pipeline_advance of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_pipeline_advance = http__ns_adobe_com_adobecloud_rel_pipeline_advance

    @property
    def http__ns_adobe_com_adobecloud_rel_pipeline_cancel(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_pipeline_cancel of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_pipeline_cancel of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_pipeline_cancel

    @http__ns_adobe_com_adobecloud_rel_pipeline_cancel.setter
    def http__ns_adobe_com_adobecloud_rel_pipeline_cancel(self, http__ns_adobe_com_adobecloud_rel_pipeline_cancel):
        """Sets the http__ns_adobe_com_adobecloud_rel_pipeline_cancel of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_pipeline_cancel: The http__ns_adobe_com_adobecloud_rel_pipeline_cancel of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_pipeline_cancel = http__ns_adobe_com_adobecloud_rel_pipeline_cancel

    @property
    def http__ns_adobe_com_adobecloud_rel_program(self):
        """Gets the http__ns_adobe_com_adobecloud_rel_program of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The http__ns_adobe_com_adobecloud_rel_program of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self._http__ns_adobe_com_adobecloud_rel_program

    @http__ns_adobe_com_adobecloud_rel_program.setter
    def http__ns_adobe_com_adobecloud_rel_program(self, http__ns_adobe_com_adobecloud_rel_program):
        """Sets the http__ns_adobe_com_adobecloud_rel_program of this PipelineExecutionStepStateLinks.


        :param http__ns_adobe_com_adobecloud_rel_program: The http__ns_adobe_com_adobecloud_rel_program of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self._http__ns_adobe_com_adobecloud_rel_program = http__ns_adobe_com_adobecloud_rel_program

    @property
    def _self(self):
        """Gets the _self of this PipelineExecutionStepStateLinks.  # noqa: E501


        :return: The _self of this PipelineExecutionStepStateLinks.  # noqa: E501
        :rtype: HalLink
        """
        return self.__self

    @_self.setter
    def _self(self, _self):
        """Sets the _self of this PipelineExecutionStepStateLinks.


        :param _self: The _self of this PipelineExecutionStepStateLinks.  # noqa: E501
        :type: HalLink
        """

        self.__self = _self

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PipelineExecutionStepStateLinks):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PipelineExecutionStepStateLinks):
            return True

        return self.to_dict() != other.to_dict()
