# coding: utf-8

"""
    Cloud Manager API

    This API allows access to Cloud Manager programs, pipelines, and environments by an authorized technical account created through the Adobe I/O Console. The base url for this API is https://cloudmanager.adobe.io, e.g. to get the list of programs for an organization, you would make a GET request to https://cloudmanager.adobe.io/api/programs (with the correct set of headers as described below). This swagger file can be downloaded from https://raw.githubusercontent.com/AdobeDocs/cloudmanager-api-docs/master/swagger-specs/api.yaml.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: opensource@shinesolutions.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pyaemcloudmanagerapi.configuration import Configuration


class RepositoryList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'total_number_of_items': 'int',
        'embedded': 'RepositoryListEmbedded',
        'links': 'ProgramListLinks'
    }

    attribute_map = {
        'total_number_of_items': '_totalNumberOfItems',
        'embedded': '_embedded',
        'links': '_links'
    }

    def __init__(self, total_number_of_items=None, embedded=None, links=None, local_vars_configuration=None):  # noqa: E501
        """RepositoryList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._total_number_of_items = None
        self._embedded = None
        self._links = None
        self.discriminator = None

        if total_number_of_items is not None:
            self.total_number_of_items = total_number_of_items
        if embedded is not None:
            self.embedded = embedded
        if links is not None:
            self.links = links

    @property
    def total_number_of_items(self):
        """Gets the total_number_of_items of this RepositoryList.  # noqa: E501


        :return: The total_number_of_items of this RepositoryList.  # noqa: E501
        :rtype: int
        """
        return self._total_number_of_items

    @total_number_of_items.setter
    def total_number_of_items(self, total_number_of_items):
        """Sets the total_number_of_items of this RepositoryList.


        :param total_number_of_items: The total_number_of_items of this RepositoryList.  # noqa: E501
        :type: int
        """

        self._total_number_of_items = total_number_of_items

    @property
    def embedded(self):
        """Gets the embedded of this RepositoryList.  # noqa: E501


        :return: The embedded of this RepositoryList.  # noqa: E501
        :rtype: RepositoryListEmbedded
        """
        return self._embedded

    @embedded.setter
    def embedded(self, embedded):
        """Sets the embedded of this RepositoryList.


        :param embedded: The embedded of this RepositoryList.  # noqa: E501
        :type: RepositoryListEmbedded
        """

        self._embedded = embedded

    @property
    def links(self):
        """Gets the links of this RepositoryList.  # noqa: E501


        :return: The links of this RepositoryList.  # noqa: E501
        :rtype: ProgramListLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this RepositoryList.


        :param links: The links of this RepositoryList.  # noqa: E501
        :type: ProgramListLinks
        """

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RepositoryList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RepositoryList):
            return True

        return self.to_dict() != other.to_dict()
